#delimit;

* revised 8/17/00 for jpube revision;
* substract stytax to create new taxinc variable;
* compute log(1-T'(state)) variable to assess state tax;
* sdmargp and sdmargt;
* compute new definitions of taxable income;
* taxct old taxinc;
* taxcs = taxct + stytax , dlogtcs, logtcs;
* taxcc = taxct + stytax + contrd , dlogtcc, logtcc;
* taxcm = taxct + stytax + contrd + mortpd , dlogtcm, logtcm;

* compute averate taxct and average broad over span of years;
* broav, taxavt, taxavs, taxavc, taxavm;
* logtavt logtavs logtavc logtavm logbrav;


* adapted to STATA from ssupbld5.sas;
* computes the two definitions of taxable income;
* taxct = constant def close to 1990 definition in real terms;
* taxlm = locally moving definition of taxable income;
* pce variable produced by fortran programs;
* now totitm replaces totald;

* cd c:\manu\papers\taxref\statend\build;
cap log close;
log using c:\manu\papers\taxref\statend\build\build1.log, replace;

clear;
set memory 600000;



/*
use d:\data\irs\tall.dta;
keep if id/50-int(id/50)==0;
save d:\data\irs\subset.dta;
clear;
*/

/*
use d:\data\irs\tall.dta;
for var agex-e90_110: replace X=0 if X==.;
drop  e90_110 e90_78 e90_75 e90_29 xbi90 psv90 prep90
e89_158 e89_156 e89_155 e89_110 e89_78 e89_75 e89_29
e89_21 e89_20 xbi89 reserved e87_20 reserve2 reserve1
e152_81 seli81 distr81 seli80 weight nsc allowii disii
rrothi rrmort cfmtet cfmtep popc sampc iweght dweght
revtax bssrct abrdxc abrdxm abrdy geothm solar
caulk window inslat pycrry addsbs rnewpy rnewex engcrd;
sort flpdyr id;
* save d:\scratch\tall.dta, replace;
gen refpce=0.929; * this is the pce for year 90;
* ttladj already defined for years 79,80,..,83;
replace ttladj=moving+empexp+iraded+keogh+penlty+almpd+secern
if flpdyr==84 | flpdyr==85 | flpdyr==86;
replace ttladj=empexp+iraded+irasec+keogh+penlty+almpd
if flpdyr==87;
replace ttladj=empexp+iraded+irasec+keogh+penlty+almpd+health
if flpdyr>=88;
replace ttladj=hsetax+empexp+iraded+irasec+keogh+penlty+almpd+health
if flpdyr==90;

gen broad=0;
replace broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi
if flpdyr<=80 | flpdyr==82 | flpdyr==83;
replace broad=agi+ttladj+divrec+inty-divint+1.5*(cgdist+cgagi)+ui-uiagi
if flpdyr==81;
replace broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi-ssagi
if flpdyr==84 | flpdyr==85 | flpdyr==86;
replace broad=agi+ttladj-ssagi
if flpdyr>=87;

gen broadn=broad-(cgdist+cgagi);
replace broadn=broad-2.5*(cgdist+cgagi) if flpdyr<=86;

gen item=0;
replace item=1 if flpdyr<87 & itded!=0;
replace item=1 if flpdyr==87 & agex==0 &
 (totitm!=2540 & totitm!=3760 & totitm!=1880);
replace item=1 if flpdyr==87 & agex>0 &
 (totitm!=3750 & totitm!=4500 & totitm!=5600 & totitm!=6200
& totitm!=6800 & totitm!=7400 & totitm!=5150 & totitm!=5900);
replace item=1 if flpdyr==88 & agex==0 &
 (totitm!=3000 & totitm!=5000 & totitm!=2500 & totitm!=4400);
replace item=1 if flpdyr==88 & agex>0 &
 (totitm!=3750 & totitm!=4500 & totitm!=5600 & totitm!=6200
& totitm!=6800 & totitm!=7400 & totitm!=5150 & totitm!=5900);
replace item=1 if flpdyr==89 & agex==0 &
 (totitm!=3100 & totitm!=5200 & totitm!=2600 & totitm!=4550);
replace item=1 if flpdyr==89 & agex>0 &
 (totitm!=3850 & totitm!=4600 & totitm!=5800 & totitm!=6400
& totitm!=7000 & totitm!=7600 & totitm!=5300 & totitm!=6050);
replace item=1 if flpdyr==90 & agex==0 &
 (totitm!=3250 & totitm!=5450 & totitm!=2725 & totitm!=4750);
replace item=1 if flpdyr==90 & agex>0 &
 (totitm!=4050 & totitm!=4850 & totitm!=6100 & totitm!=6750
& totitm!=7400 & totitm!=8050 & totitm!=5550 & totitm!=6350);

gen stdded=0;
replace stdded=2300 if flpdyr<=84 & (mars==1 | mars==4);
replace stdded=3400 if flpdyr<=84 & (mars==2 | mars==5);
replace stdded=1700 if flpdyr<=84 & (mars==3 | mars==6);
replace stdded=2390 if flpdyr==85 & (mars==1 | mars==4);
replace stdded=3540 if flpdyr==85 & (mars==2 | mars==5);
replace stdded=1770 if flpdyr==85 & (mars==3 | mars==6);
replace stdded=2480 if flpdyr==86 & (mars==1 | mars==4);
replace stdded=3670 if flpdyr==86 & (mars==2 | mars==5);
replace stdded=1835 if flpdyr==86 & (mars==3 | mars==6);
replace stdded=2540 if flpdyr==87 & (mars==1 | mars==4);
replace stdded=3760 if flpdyr==87 & (mars==2 | mars==5);
replace stdded=1880 if flpdyr==87 & (mars==3 | mars==6);
replace stdded=3000 if flpdyr==88 & (mars==1);
replace stdded=4400 if flpdyr==88 & (mars==4);
replace stdded=5000 if flpdyr==88 & (mars==2 | mars==5);
replace stdded=2500 if flpdyr==88 & (mars==3 | mars==6);
replace stdded=5100 if flpdyr==89 & (mars==1);
replace stdded=6550 if flpdyr==89 & (mars==4);
replace stdded=9200 if flpdyr==89 & (mars==2);
replace stdded=7200 if flpdyr==89 & (mars==5);
replace stdded=2000 if flpdyr==89 & (mars==3 | mars==6);
replace stdded=5300 if flpdyr==90 & (mars==1);
replace stdded=6800 if flpdyr==90 & (mars==4);
replace stdded=9550 if flpdyr==90 & (mars==2);
replace stdded=7500 if flpdyr==90 & (mars==5);
replace stdded=2050 if flpdyr==90 & (mars==3 | mars==6);

* standard deduction in 1990;
gen refded=0;
replace refded=5300 if (mars==1);
replace refded=6800 if (mars==4);
replace refded=9550 if (mars==2);
replace refded=7500 if (mars==5);
replace refded=2050 if (mars==3 | mars==6);

* age & blindness exemptions using 1990 tax year;
replace refded=refded+650*(xtot-xother) if flpdyr<=86
& (mars==2 | mars==3 | mars==5 | mars==6);
replace  refded=refded+800*(xtot-xother) if flpdyr<=86
& (mars==1 | mars==4);
replace refded=refded+650*max(agexb,agex) if flpdyr>=87
& (mars==2 | mars==3 | mars==5 | mars==6);
replace refded=refded+800*max(agexb,agex) if flpdyr>=87  & (mars==1 | mars==4);
gen taxct=0; * TAXABLE INCOME CONSTANT DEF;
save d:\scratch\tall.dta, replace;
*/

log off;
for A in num 1/3:

clear \
infile flpdyr id taxf0 taxs0 wratef0 wrates0 taxf1 taxs1
wratef1 wrates1 pce taxlm0 taxlm1 taxln0 taxln1 using
"c:\manu\data\paneluse\taxsim\wagA.tab" \
replace flpdyr=flpdyr-1900 \
sort flpdyr id \
merge flpdyr id using "d:\scratch\tall.dta" \
sort flpdyr id \
sum _merge \ drop _merge \
save "d:\scratch\tallA.dta", replace \
clear \
infile flpdyr id taxf0b taxs0b ratef0 rates0 taxf1b taxs1b
ratef1 rates1 pceb taxlm0b taxlm1b taxln0b taxln1b using
"c:\manu\data\paneluse\taxsim\broA.tab" \
replace flpdyr=flpdyr-1900 \
sort flpdyr id \
merge flpdyr id using "d:\scratch\tallA.dta" \
drop pceb taxf0b taxs0b taxf1b taxs1b taxlm0b taxlm1b taxln0b
taxln1b \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce-xother*2050-refded)/refpce
if flpdyr<=80 \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totitm*refpce/pce)/refpce
if flpdyr<=80 & item==1 & (totitm+nonit+moving)*refpce/pce>refded \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec+inty-divint+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce-xother*2050-refded)/refpce
if flpdyr==81 \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec+inty-divint+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totitm*refpce/pce)/refpce
if flpdyr==81 & item==1 & (totitm+nonit+moving)*refpce/pce>refded \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce
-xother*2050-refded)/refpce if flpdyr>=82 & flpdyr<=86 \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totitm*refpce/pce)/refpce
if flpdyr>=82 & flpdyr<=86 & item==1 &
(totitm+nonit+moving)*refpce/pce>refded \
replace taxct=(refpce*(agi-cgagi-cgdist-ssagi+iraded+keogh+irasec)/pce-xtot*2050-refded)/refpce
if flpdyr>=87 & flpdyr<=89  \
replace taxct=(refpce*(agi-cgagi-cgdist-ssagi+iraded+keogh+irasec)/pce-xtot*2050-totitm*refpce/pce)/refpce
if flpdyr>=87 & flpdyr<=89 & item==1 & totitm*refpce/pce>refded  \
replace taxct=(agi-cgagi-cgdist-ssagi+hsetax+iraded+keogh+irasec-xtot*2050-totitm)/refpce
if flpdyr==90 \
gen taxcs=taxct \
replace taxcs=taxct+stytax/pce if stytax>0 & item==1 \
gen taxcc=taxcs \
replace taxcc=taxcs+contrd/pce if contrd>0 & item==1 \
gen taxcm=taxcc \
replace taxcm=taxcc+mortpd/pce if mortpd>0 & item==1 \
sort id \
egen cav=count(broadn), by (id) \
egen cvt=sum(taxct), by (id) \
egen cvs=sum(taxcs), by (id) \
egen cvc=sum(taxcc), by (id) \
egen cvm=sum(taxcm), by (id) \
egen broav=sum(broadn/pce), by (id) \
egen taxavt=sum(taxct), by (id) \
egen taxavs=sum(taxcs), by (id) \
egen taxavc=sum(taxcc), by (id) \
egen taxavm=sum(taxcm), by (id) \

keep
taxf0 taxs0 taxf1 taxs1
ratef0 ratef1 rates0 rates1
wratef0 wratef1 wrates0 wrates1
taxlm0 taxlm1 taxln0 taxln1 pce
item stdded refded broadn refpce taxct taxcs taxcc taxcm broad
broav taxavt taxavs taxavc taxavm
cav cvt cvs cvc cvm
flpdyr id mars state  xtot xother
agi wages  cgagi cgdist ttladj
itded nonit exempt totitm agex agexb newtxy txst
party partl sbtly sbtlss esty estlss rentyl ryltyl
frent passl npassl smbloss sbnpls
partny smbpy smbnpy passy npassy stytax mortpd contrd \
save "d:\scratch\tallA.dta", replace;


log on;
* 1 year lag;
for X in num 79/90: clear \ use "d:\scratch\tall1.dta" \ keep if flpdyr==X \
sort id \ save "d:\scratch\tallsX.dta", replace;
for X in num 80/90 \ Y in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \ for Z in var ratef0-taxavm:
rename Z Z2 \ sort id \ save "d:\scratch\dtallY.dta", replace;
for X in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \
merge id using "d:\scratch\dtallX.dta" \
keep if _merge==3 \ drop _merge \
save "d:\scratch\dtallX.dta", replace;
clear; use "d:\scratch\dtall79.dta";
for X in num 80/89: append using "d:\scratch\dtallX.dta";
save "d:\scratch\d1tallex", replace;
for X in num 1/3: gen mrsX=0  \ replace mrsX=1 if mars==X;
save "d:\scratch\d1tallex", replace;

* 2 year lag;
for X in num 79/90: clear \ use "d:\scratch\tall2.dta" \ keep if flpdyr==X \
sort id \ save "d:\scratch\tallsX.dta", replace;
for X in num 81/90 \ Y in num 79/88:
clear \ use "d:\scratch\tallsX.dta" \ for Z in var ratef0-taxavm:
rename Z Z2 \ sort id \ save "d:\scratch\dtallY.dta", replace;
for X in num 79/88:
clear \ use "d:\scratch\tallsX.dta" \
merge id using "d:\scratch\dtallX.dta" \
keep if _merge==3 \ drop _merge \
save "d:\scratch\dtallX.dta", replace;
clear; use "d:\scratch\dtall79.dta";
for X in num 80/88: append using "d:\scratch\dtallX.dta";
save "d:\scratch\d2tallex", replace;
for X in num 1/3: gen mrsX=0  \ replace mrsX=1 if mars==X;
save "d:\scratch\d2tallex", replace;

* 3 year lag;
for X in num 79/90: clear \ use "d:\scratch\tall3.dta" \ keep if flpdyr==X \
sort id \ save "d:\scratch\tallsX.dta", replace;
for X in num 82/90 \ Y in num 79/87:
clear \ use "d:\scratch\tallsX.dta" \ for Z in var ratef0-taxavm:
rename Z Z2 \ sort id \ save "d:\scratch\dtallY.dta", replace;
for X in num 79/87:
clear \ use "d:\scratch\tallsX.dta" \
merge id using "d:\scratch\dtallX.dta" \
keep if _merge==3 \ drop _merge \
save "d:\scratch\dtallX.dta", replace;
clear; use "d:\scratch\dtall79.dta";
for X in num 80/87: append using "d:\scratch\dtallX.dta";
save "d:\scratch\d3tallex", replace;
for X in num 1/3: gen mrsX=0  \ replace mrsX=1 if mars==X;
save "d:\scratch\d3tallex", replace;


for A in num 1/3: clear \ use "d:\scratch\dAtallex" \
gen flpdyr2=flpdyr+A \
gen broadr=broad/pce  \
gen broad2r=broad2/pce2  \
gen lnbroad=log(broadr)  \
gen dlogb=log(broad2r/broadr)  \
gen incefp=log((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce))  \
gen fincefp=log((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce))  \
gen inceff=log((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce))  \
gen finceff=log((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce))  \
gen incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr  \
gen inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr  \
gen dmargp=log((100-ratef1-rates1)/(100-ratef0-rates0))  \
gen dmargt=log((100-ratef02-rates02)/(100-ratef0-rates0))  \
gen fdmargp=log((100-ratef1)/(100-ratef0))  \
gen fdmargt=log((100-ratef02)/(100-ratef0))  \
gen sdmargp=log((100-rates1)/(100-rates0))  \
gen sdmargt=log((100-rates02)/(100-rates0))  \
gen wdmargp=log((100-wratef1-wrates1)/(100-wratef0-wrates0))  \
gen wdmargt=log((100-wratef02-wrates02)/(100-wratef0-wrates0))  \
gen wfdmargp=log((100-wratef1)/(100-wratef0))  \
gen wfdmargt=log((100-wratef02)/(100-wratef0))  \

gen dlogbr=log(broadn2*pce/(broadn*pce2)) \
gen logbr=log(broadn/pce) \
gen br2=(broadn/pce)^2 \
gen dlogtlm=log(taxlm02/taxlm1) \
gen logtlm=log(taxlm1/pce2) \
gen taxlmr=taxlm1/pce2 \
replace taxlm02=taxlm02-cgagi2-cgdist2 \
replace taxlm1=taxlm1-(cgagi+cgdist)*pce2/pce \
replace dlogtlm=log(taxlm02/taxlm1) \
replace logtlm=log(taxlm1/pce2) \
replace taxlmr=taxlm1/pce2 \
replace taxln02=taxln02-cgagi2-cgdist2 \
replace taxln1=taxln1-(cgagi+cgdist)*pce2/pce \
gen dlogtln=log(taxln02/taxln1) \
gen logtln=log(taxln1/pce2) \
gen taxlnr=taxln1/pce2 \
* gen dtaxln=log(taxln02/taxln1) \
gen dlogtct=log(taxct2/taxct) \ gen logtct=log(taxct) \
gen dlogtcs=log(taxcs2/taxcs) \ gen logtcs=log(taxcs) \
gen dlogtcc=log(taxcc2/taxcc) \ gen logtcc=log(taxcc) \
gen dlogtcm=log(taxcm2/taxcm) \ gen logtcm=log(taxcm) \
gen logbrav=log((broav-broadn2/pce2)/(cav-1)) \
gen logtavt=log((taxavt-taxct2)/(cvt-1)) \
gen logtavc=log((taxavc-taxct2)/(cvc-1)) \
gen logtavs=log((taxavs-taxct2)/(cvs-1)) \
gen logtavm=log((taxavm-taxct2)/(cvm-1)) \


gen lnwag=log(wages/pce) \
gen dlnwag=log((wages2/pce2)/(wages/pce)) \
gen wagr=wages/pce \
gen wag2=(wages/pce)^2 \
gen wag3=(wages/pce)^3 \
gen year79=0 \gen year80=0 \gen year81=0 \gen year82=0 \
gen year83=0 \gen year84=0 \gen year85=0 \gen year86=0 \
gen year87=0 \gen year88=0 \gen year89=0 \
replace year79=1 if flpdyr==79 \
replace year80=1 if flpdyr==80 \
replace year81=1 if flpdyr==81 \
replace year82=1 if flpdyr==82 \
replace year83=1 if flpdyr==83 \
replace year84=1 if flpdyr==84 \
replace year85=1 if flpdyr==85 \
replace year86=1 if flpdyr==86 \
replace year87=1 if flpdyr==87 \
replace year88=1 if flpdyr==88 \
replace year89=1 if flpdyr==89 \
gen broadnr=broadn/pce \
gen deduc=totitm/pce \ replace deduc=refded if refded>totitm/pce \
gen deduc2=totitm2/pce2 \ replace deduc2=refded2 if refded2>totitm2/pce2 \
gen taxct2p=taxct2+deduc2-deduc \
gen dlogtcp=log(taxct2p/taxct) \
mkspline spltct 10 = logtct, pctile \
mkspline splbro 10 = logbr, pctile \
mkspline splwag 10 = lnwag, pctile \
gen cgain=cgagi+cgdist \
replace cgain=2.5*cgain if flpdyr<=86 \
gen cgain2=cgagi2+cgdist2 \
replace cgain2=2.5*cgain2 if flpdyr2<=86 \
gen logbrc=log(broadn/pce+cgain/pce) \
gen dlogbrc=log(broadn2/pce2+cgain2/pce2)-log(broadn/pce+cgain/pce) \
gen logtctc=log(taxct+cgain/pce) \
gen dlogtctc=log(taxct2+cgain2/pce2)-log(taxct+cgain/pce) \

save "d:\scratch\dAtallex", replace;

log close;

/*

replace broav=(broav-broadn/pce)/(cav-1) if cav>1 \
replace taxavt=(taxavt-taxct)/(cvt-1) if cvt>1 \
replace taxavs=(taxavs-taxcs)/(cvs-1) if cvs>1 \
replace taxavc=(taxavc-taxcc)/(cvc-1) if cvc>1 \
replace taxavm=(taxavm-taxcm)/(cvm-1) if cvm>1 \

gen logtavt=log(taxavt) \
gen logtavs=log(taxavs) \
gen logtavc=log(taxavc) \
gen logtavm=log(taxavm) \
gen logbrav=log(broav) \


DATA bobo.d3fel;
set bobo.d3tall;
if flpdyr=85;
run;
